# frozen_string_literal: true

# checker Api::Dmo::HermesController avant d'ajouter des méthodes
module Hermes
  module Api
    module Dmo
      class ContactGroupsController < Hermes::Api::Dmo::ApplicationController
        VALID_OPERATORS = %w[
          $in
          $nin
          $ne
          $gt
          $gte
          $lt
          $lte
          $regex
        ]

        ACCEPTABLE_PARAMS = %w[
          ids
          contact_ids
          main_contact_id
          entity_id
          lessor_id
        ]

        REGEX_PARAMS = %w[
        ]

        MUTATE_PARAMS = %i[
          contact_ids
          main_contact_id
          entity_id
          lessor_id
        ]
        mutate_params_only(*MUTATE_PARAMS)

        def index
          acceptable_params *ACCEPTABLE_PARAMS
          regex_params *REGEX_PARAMS
          valid_operators *VALID_OPERATORS
          super
        end
      end
    end
  end
end
