# frozen_string_literal: true

module Hermes
  class LogJob < ActiveJob::Base
    queue_as :x_hermes_log
    
    def perform(*attributes)
      attributes&.first&.delete('_aj_symbol_keys')
      # Get or create queue
      redis_key = 'redis_hermes_logs_queue'
      serialized_queue = $redis.get(redis_key)
      queue = []
      if serialized_queue
        queue = JSON.parse serialized_queue
      end

      # Push log attributes in queue
      queue.push(*attributes)

      # Create logs if queue is full
      if queue.count >= 10
        Log.create!(queue)
        queue = []
      end

      # Set queue in cache if not full
      $redis.set(redis_key, queue.to_json)
    end
  end
end
