module Hermes
  class ThresholdsApplier
    @@offers_slugs = ["housing_offers", "dev_housing_offers"]
    @@thresholds_slug = "thresholds"
    @@thresholds_indexes = (1..6)
    @@threshold_prefixe = "threshold_category_"
    @@ceil_prefixe = "ceil_category_"
    @@floor_prefixe = "floor_category_"
    @@maximum_threshold_index = 12

    @@threshold_type_field = "threshold_type"
    @@threshold_subtype_field = "threshold_subtype"

    @@has_floor_field = "has_floor"

    @@thresholds_map_field = "thresholds_map"
    @@thresholds_floors_field = "floors_list"
    @@thresholds_ceil_field = "thresholds_list"
    @@thresholds_another_person_field = "another_person"

    @@threshold_refresh_field = "thresholds_refresh"

    def initialize params
      @offer = params[:offer] if params[:offer]
      @threshold_id = params[:threshold_id] if params[:threshold_id]

      set_all

      return self
    end

    def set_all
      @target = if @offer.present?
                  set_offer
                  set_threshold
                  set_thresholds_list
                  'offer'
                elsif @threshold_id.present?
                  set_threshold
                  set_offers_list
                  'threshold'
                end
    end

    def set_offer
      # TODO : change with new class, peharps offer ? Charlie ?
      @offer_threshold_type = @offer&.threshold_type
      @offer_threshold_subtype = @offer&.threshold_subtype
    end

    def set_threshold
      @threshold = 	if !@offer
                      # TODO : change with new class, peharps threshold ? Charlie ?
                      Hermes::Threshold.find_by(id: @threshold_id)
                    else
                      Hermes::Threshold.find_by(type: @offer_threshold_type)
                    end
      # @threshold_has_floor = @threshold&.has_floor
    end

    def set_thresholds_list
      # TODO : change with new class, peharps threshold ? Charlie ?
      @thresholds_list = Hermes::Threshold.where({})
    end

    def set_offers_list
      # TODO : change with new class, peharps offer ? Charlie ?
      @offers_list = Hermes::HousingOffer.where(threshold_type: @threshold.type)
    end

    def update_offer_thresholds offer
      # TODO : change to remove superfields
      sfs = {}
      threshold_subtype = @threshold.send(@@thresholds_map_field)[@offer_threshold_subtype]
      ceils_list = threshold_subtype[@@thresholds_ceil_field]
      floors_list = threshold_subtype[@@thresholds_floors_field] || (1..@@maximum_threshold_index).map {0}
      threshold_add = threshold_subtype[@@thresholds_another_person_field]
      max = 0
      @@thresholds_indexes.each do |i|
        @offer.send("#{@@ceil_prefixe}#{i}=", ceils_list[i-1])
        @offer.send("#{@@floor_prefixe}#{i}=", floors_list[i-1])
        max = i
      end
      (max+1..@@maximum_threshold_index).each do |i|
        @offer.send("#{@@ceil_prefixe}#{i}=", ceils_list[5] + ((i-max) * threshold_add))
        @offer.send("#{@@floor_prefixe}#{i}=", floors_list[5] > 0 ? ceils_list[5] + ((i-max) * threshold_add) : 0)
      end
    end

    def apply_thresholds
      case @target
      when "offer"
        if @offer_threshold_type && @offer_threshold_subtype
          update_offer_thresholds @offer
        end
      when "threshold"
        @offers_list.each do |offer|
          true if update_offer_thresholds offer
        end
      end
      # puts "target is #{@target}"
      # target_to_update = send(@target)
      # puts "target is eventualy #{target_to_update}"
      # target_to_update.superfields = target_to_update.reload.superfields.merge({@@threshold_refresh_field.to_sym => "off"})
      # target_to_update.save
    end

    def offer
      @offer
    end
    def offer_sf
      @offer_sf
    end

    def threshold
      @threshold
    end
    def threshold_sf
      @threshold_sf
    end
  end
end