# frozen_string_literal: true


=begin
nud = Hermes::Nud.first
ha = Hermes::HousingApplication.first
   code = "RADATT"
  
      so = Hermes::BoClient::UpdateStatusTask.new({
                                               housing_request_id: ha.housing_request_id,
                                               housing_offer_id: ha.housing_offer_id,
                                               code_evenement: code })
so.to_xml
ExecuteSopraTaskJob.perform_now(so.endpoint, so.to_xml)
=end

module Hermes
  module BoClient
    class UpdateStatusTask < BaseTask
      
      def initialize(options = {})
        @xsd = 'StatutProposition.xsd'
        super(options)
      end
      
      endpoint {'/ws/rest/als/demande/v1/modifierStatut'}
      
      task_name 'updatestatus'
      type_flux 'BIEN'
      mapping 'Hermes::BoClient::Mappings::HousingApplicationMap'
      
      params *%i[
        refInterneDemande
        refInterneOffre
        code_evenement
      ]
      
      def to_xml
        namespaces = {
            'xmlns:ns2' => 'http://v1.als.ikos.webservice.immobilier.sopra/demande/propositionEvenement'
        }
        builder = Nokogiri::XML::Builder.new(encoding: 'UTF-8') do |b|
          b[:ns2].propositionEvenement(namespaces) do
            
            b.refInterneDemande mapping.refInterneDemande do
              b.parent.namespace = nil
            end
            b.refInterneOffre mapping.refInterneOffre do
              b.parent.namespace = nil
            end
            b.code_evenement mapping.code_evenement do
              b.parent.namespace = nil
            end
		        b.date_evenement mapping.date_evenement do
              b.parent.namespace = nil
            end
            b.date_survenance_evenement mapping.date_survenance_evenement do
              b.parent.namespace = nil
            end

            b.rang_decision mapping.rang_decision do
              b.parent.namespace = nil
            end


          end
      
         
        end
        builder.to_xml
      end
    end
  end
end
