# frozen_string_literal: true

require 'rails_helper'
require 'vcr_config'
require [Hermes::Engine.root, %w[lib hermes rex_client tasks]].flatten.join('/').to_s
require [Hermes::Engine.root, %w[lib hermes rex_client]].flatten.join('/').to_s

HERMES_CONFIG['identity_provider_key'] = 'als_hermes_salarie'

RSpec.describe Hermes::RexClient::UpdateContactTask, type: :helper do
  let!(:entity1) { create(:entity, id_cristal: '686', siret: '00000000000001') }
  let!(:entity2) { create(:entity, id_cristal: '1701', siret: '00000000000002') }
  let!(:user) { create(:user, email: 'deborah.melianiatlan@yopmail.com', password: Devise.friendly_token[0,20], group_ids: [entity2.group_id]) }
  let!(:identity_provider) {create(:identity_provider,
    key: 'als_hermes_salarie',
    identifier_rights_url: 'https://rec.client.almerys.com/authz/realms/ALS/protocol/openid-connect/token',
    identifier_client_id: 'ALS_HERMES_BACK',
    identifier_client_secret: '77ff390e-6cca-4f09-9840-0e799a47a0ac',
    identifier_subject_issuer: 'ALS',
    account_service_url: 'https://rec.client.almerys.com/auth/realms/ALS/protocol/openid-connect/token',
    account_service_client_id: 'ALS_HERMES_SERVICE_ACCOUNT',
    account_service_client_secret: '28733e0d-c363-44a2-9f85-ea7d4784a4ad',
    create_user_url: 'https://api-rcc.be-ys.com/als-back/rcc/v1/accounts',
    add_roles_user_url: 'https://api-rcc.almerys.com/iam/api/authorization/clients/ALS_HERMES_BACK/users/{login}/roles/{role}?realm=ALS',
    create_user_headers: {
      'Content-Type': 'application/json',
      'X-GeXRT-API-Key': '169c24b0-a763-40f7-877d-7f94967ffea4',
    }
  )}

  # describe 'Existing user' do
  #   it 'update user' do
  #     VCR.use_cassette("rex_update_existing_user", :match_requests_on => [:method, :uri, :path]) do
  #       client = Hermes::RexClient::Client.new
  #       rex_entity = client.search_contacts({'fields.email' => 'deborah.melianiatlan@yopmail.com'}).first
  #       Hermes::RexClient::UpdateContactTask.new.update_contact(rex_entity, client)
  #     end
  #     expect(user.reload.first_name).to eq "DEBORAH"
  #     expect(user.reload.auth_roles).to eq ["cre"]
  #     expect(User.all().count).to eq(1)
  #     expect(Hermes::Entity.writable_by(user).find_by(id: entity1.id)).not_to be_nil  
  #     expect(Hermes::Entity.writable_by(user).find_by(id: entity2.id)).to be_nil
  #   end
  # end

  # describe 'Not existing user' do
  #   it 'create user' do
  #     VCR.use_cassette("rex_create_new_user", :match_requests_on => [:method, :uri, :path]) do
  #       client = Hermes::RexClient::Client.new
  #       rex_entity = client.search_contacts({'fields.email' => 'mohamed.benhlima@yopmail.com'}).first
  #       Hermes::RexClient::UpdateContactTask.new.update_contact(rex_entity, client)
  #     end
  #     created_user = User.find_by(email: 'teresa.dossantos@yopmail.com')
  #     expect(User.all().count).to eq(2)
  #     expect(created_user.first_name).to eq "TERESA"
  #     expect(Hermes::Entity.writable_by(created_user).find_by(id: entity1.id)).to be_nil
  #     expect(Hermes::Entity.writable_by(created_user).find_by(id: entity2.id)).not_to be_nil
  #   end

  # end
  # describe 'Existing user on beiam' do
  #   it 'create user' do
  #     VCR.use_cassette("rex_update_existing_user_on_beiam", :match_requests_on => [:method, :uri, :path]) do
  #       client = Hermes::RexClient::Client.new
  #       rex_entity = client.search_contacts({'fields.email' => 'teresa.dossantos2@actionlogement.fr'}).first
  #       Hermes::RexClient::UpdateContactTask.new.update_contact(rex_entity, client)
  #     end
  #     created_user = User.find_by(email: 'teresa.dossantos2@yopmail.com')
  #     expect(User.all().count).to eq(2)
  #     expect(created_user.first_name).to eq "TERESA"
  #     expect(Hermes::Entity.writable_by(created_user).find_by(id: entity1.id)).to be_nil
  #     expect(Hermes::Entity.writable_by(created_user).find_by(id: entity2.id)).not_to be_nil
  #   end
  # end
end
